#include "Gra.ch"
#include "Xbp.ch"
#include "Common.ch"
#include "Appevent.ch"
#include "Font.ch"

PROCEDURE AppSys
RETURN

PROCEDURE Main
LOCAL nEvent, oXbp, mp1, mp2
LOCAL oDlg

   oDlg := SleDlg():New()
   oDlg:Create()
   CenterControl(oDlg)

   SetAppFocus(oDlg:oSLE1)

   nEvent := xbe_None
   WHILE nEvent != xbeP_Close
      nEvent := AppEvent ( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent ( nEvent, mp1, mp2 )
      IF nEvent == xbeP_Quit
         QUIT   // AppQuit()
      ENDIF
   ENDDO
RETURN

* ----------------------------------------------------------------- *

CLASS SleForm FROM XbpDialog
   EXPORTED:
      VAR editControls

      VAR oSLE1
      VAR oSLE2
      VAR oSLE3
      VAR ButtonOK

      METHOD init
      METHOD create
ENDCLASS

METHOD SleForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
LOCAL cVarA := "AAAAAAAAAA"
LOCAL cVarB := "BBBBBBBBBB"
LOCAL cVarC := "CCCCCCCCCC"
LOCAL aPres := { { XBP_PP_BGCLR, XBPSYSCLR_ENTRYFIELD },;
                 { XBP_PP_FGCLR, XBPSYSCLR_WINDOWTEXT },;
                 { XBP_PP_HILITE_BGCLR, GRA_CLR_RED },;
                 { XBP_PP_HILITE_FGCLR, XBPSYSCLR_HILITEFOREGROUND } }

   DEFAULT oParent  TO AppDesktop(), ;
           aPos     TO {0,0}, ;
           lVisible TO .F.

   DEFAULT aPP TO {}
   AAdd ( aPP, { XBP_PP_COMPOUNDNAME, "8.Arial" } )

   IF Empty(aSize) == .T.
      IF IsMemberVar(self,"ClientSize") == .T.
         aSize := {0,0}
      ELSE
         aSize := {143,196}
      ENDIF
   ENDIF

   ::XbpDialog:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   IF aSize[1] == 0 .AND. aSize[2] == 0
      ::XbpDialog:ClientSize := {127,157}
   ENDIF
   ::XbpDialog:taskList := .T.
   ::XbpDialog:title := "Neues Formular"

   ::editControls := {}

   ::oSLE1    := XbpSLE():new( ::drawingArea, , {12,108}, {96,24}, aPres )
   ::oSLE1:dataLink := { | x | IIf( x==NIL, cVarA, cVarA := x ) }
   ::oSLE1:tabStop := .T.
   AADD( ::editControls, ::oSLE1 )

   ::oSLE2    := XbpSLE():new( ::drawingArea, , {12,80}, {96,24}, aPres )
   ::oSLE2:dataLink := { | x | IIf( x==NIL, cVarB, cVarB := x ) }
   ::oSLE2:tabStop := .T.
   AADD( ::editControls, ::oSLE2 )

   ::oSLE3    := XbpSLE():new( ::drawingArea, , {12,52}, {96,24}, aPres )
   ::oSLE3:dataLink := { | x | IIf( x==NIL, cVarC, cVarC := x ) }
   ::oSLE3:tabStop := .T.
   AADD( ::editControls, ::oSLE3 )

   ::ButtonOK := XbpPushButton():new( ::drawingArea, , {12,20}, {96,24}, { { XBP_PP_BGCLR, XBPSYSCLR_BUTTONMIDDLE }, { XBP_PP_FGCLR, -58 } } )
   ::ButtonOK:caption := "Ok"
   ::ButtonOK:tabStop := .F.
   ::ButtonOK:activate := {|| Gather( ::editControls ), PostAppEvent( xbeP_Close ) }

RETURN self

METHOD SleForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::XbpDialog:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   ::oSLE1:create()
   ::oSLE2:create()
   ::oSLE3:create()

   ::ButtonOK:create()

RETURN self

* ----------------------------------------------------------------- *

CLASS SleDlg FROM SleForm
   EXPORTED:
      METHOD init
      METHOD create
ENDCLASS

METHOD SleDlg:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SleForm:init( oParent, oOwner, aPos, aSize, aPP, lVisible )
RETURN self

METHOD SleDlg:create( oParent, oOwner, aPos, aSize, aPP, lVisible )
   ::SleForm:create( oParent, oOwner, aPos, aSize, aPP, lVisible )

   AEVAL( ::EditControls, { | oXbp | oXbp:SetData() } )
   AEVAL( ::EditControls, { | oXbp | oXbp:setInputFocus := ;
                          {|u1,u2,o| o:setMarked({1,o:bufferLength+1})}})

   ::show()
RETURN self

* ----------------------------------------------------------------- *


//EOF
/////